# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from enum import Enum, EnumMeta
from six import with_metaclass

class _CaseInsensitiveEnumMeta(EnumMeta):
    def __getitem__(self, name):
        return super().__getitem__(name.upper())

    def __getattr__(cls, name):
        """Return the enum member matching `name`
        We use __getattr__ instead of descriptors or inserting into the enum
        class' __dict__ in order to support `name` and `value` being both
        properties for enum members (which live in the class' __dict__) and
        enum members themselves.
        """
        try:
            return cls._member_map_[name.upper()]
        except KeyError:
            raise AttributeError(name)


class DatasetConsumptionType(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):

    RUN_INPUT = "RunInput"
    REFERENCE = "Reference"

class DatasetDeliveryMechanism(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):

    DIRECT = "Direct"
    MOUNT = "Mount"
    DOWNLOAD = "Download"
    HDFS = "Hdfs"

class DatasetOutputType(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):

    RUN_OUTPUT = "RunOutput"
    REFERENCE = "Reference"

class ExperimentViewType(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):
    """ViewType filters experiments by their archived state. Default is ActiveOnly
    """

    DEFAULT = "Default"
    ALL = "All"
    ACTIVE_ONLY = "ActiveOnly"
    ARCHIVED_ONLY = "ArchivedOnly"

class MetricValueType(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):

    INT = "Int"
    DOUBLE = "Double"
    STRING = "String"
    BOOL = "Bool"
    ARTIFACT = "Artifact"

class RunStatus(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):
    """Gets span status.
    OpenTelemetry sets it to https://github.com/open-telemetry/opentelemetry-
    dotnet/blob/master/src/OpenTelemetry.Api/Trace/Status.cs
    That status enums are not very meaningful to us, so we customize this.
    """

    NOT_STARTED = "NotStarted"
    UNAPPROVED = "Unapproved"
    PAUSING = "Pausing"
    PAUSED = "Paused"
    STARTING = "Starting"
    PREPARING = "Preparing"
    QUEUED = "Queued"
    RUNNING = "Running"
    FINALIZING = "Finalizing"
    CANCEL_REQUESTED = "CancelRequested"
    COMPLETED = "Completed"
    FAILED = "Failed"
    CANCELED = "Canceled"

class StoredProcedureParameterType(with_metaclass(_CaseInsensitiveEnumMeta, str, Enum)):

    STRING = "String"
    INT = "Int"
    DECIMAL = "Decimal"
    GUID = "Guid"
    BOOLEAN = "Boolean"
    DATE = "Date"
